exec("./lib/vizard.cs");
exec("./lib/nodes.cs");

if (!isObject(MainNodeGroup)) 
{
	NodeGroup("MainNodeGroup");
}

function viz(%v)
{
	MainNodeGroup.import("Add-Ons/Script_BSP_MapDisplay/" @ %v);
}

function box(%v)
{
  %fileName = "Add-Ons/Script_BSP_MapDisplay/" @ %v;

  if (!isFile(%fileName))
  {
    return;
  }

  for (%i = MissionCleanup.getCount() - 1; %i >= 0; %i--)
  {
    %obj = MissionCleanup.getObject(%i);

    if (%obj.getType() & $TypeMasks::StaticShapeObjectType)
    {
      %obj.delete();
    }
  }

  %fp = new FileObject();
  %fp.openForRead(%fileName);

  while (!%fp.isEOF())
  {
    %line = %fp.readLine();
    %min = getMin(%lowest, getWord(%line, 2) - getWord(%line, 5) / 2);
  }

  %fp.close();
  %fp.openForRead(%fileName);

  while (!%fp.isEOF())
  {
    %line = %fp.readLine();

    %pos = getWords(%line, 0, 2);
    %xyz = getWords(%line, 3, 5);
    %color = getWords(%line, 6, 8) SPC 1;

    %pos = vectorScale(%pos, 1 / 24);
    %xyz = vectorScale(%xyz, 1 / 24);

    %pos = vectorAdd(%pos, "0 0 40.3282");

    // %color =
    //   r(getword(%xyz,0)) SPC
    //   r(getword(%xyz,1)) SPC
    //   r(getword(%xyz,2)) SPC
    //   1;

    //%color = 0.4 + getRandom() * 0.2 SPC 0.4 + getRandom() * 0.2 SPC 0.4 + getRandom() * 0.2 SPC 1;

    %obj = createShape(CubeCollisionShapeData, %color);

    %obj.setTransform(%pos);
    %obj.setScale(%xyz);
  }

  %fp.close();
  %fp.delete();
}

function r(%v) { return %v - mfloor(%v); }